# coding utf 8 

#################################################################################################
#    Corrigé du Devoir maison n°1: 2017-2018   Suite de Syracuse  d'après Euler Project 14
#####################################################################################################

## Modules utilisés

import time 


## Fonctions utilisées


# Q1
def f(n):
    if n % 2 ==0:
        return n//2
    else:
        return 3*n+1

# Q2

def longueur_chaine(c):
    n = 1
    u = c
    while u != 1:
        u = f(u)
        n += 1
    return n

# Q3

def max_chaine(c):
    uMax = c
    u = c
    while u != 1:
        u = f(u)
        if u > uMax:
            uMax = u
    return uMax

# Q4

def longueur_maximale(N):
    """Données N un entier strictement positif
       Résultat: la plus grande longueur de chaîne et sa valeur de départ c parmi les chaînes dont la valeur de départ c est comprise entre 1 et N"""
    longueur_max = 1 
    c_max = 1 # la valeur de départ de la chaîne de longueur maximale
    for c in range(1, N+1):
        if longueur_chaine(c) > longueur_max :
           longueur_max = longueur_chaine(c)
           c_max = c
    return longueur_max, c_max


## Pour répondre à la question posée, on exécute le script suivant, qui donne en plus le temps de calcul

t0 = time.clock()
print(longueur_maximale(10**5))
t1 = time.clock()
duree_calcul = t1 -t0
print("temps de calcul ", duree_calcul)

# renvoie (351, 77031) pour N = 10**5 en 5 s et (525,837799) pour 10**6 en 53 s
# Parmi les chaînes dont la valeur de départ c est comprise entre 1 et 10^6, la plus longue est obtenue pour une valeur de départ c = 837799, et sa longueur vaut 525.
# Le temps de calcul est de 52 secondes sur mon PC.


## Améliorations possibles

"""On doit pouvoir accélérer les temps de calculs en mémorisant les calculs de longueurs de chaînes... On va gagner du temps en perdant de l'espace...
On crée un dictionnaire dans lequel, on va stocker au fur et à mesure les longueurs calculées (on note l(c) la longueur de la chaîne démarrant à c):
* Pour c = 2, 2 n'est pas encore dans le dico, on itère on tombe sur 1 qui est dans dico. Dans dico, on a maintenant les longueurs de 1 et 2.
* On passe à c =3. 3 n'est pas dans dico, on itère, on obtient 10 qui n'est pas dico, on continue jusqu'à ce l'on tombe dans le dico. On obtient ainsi comme chaîne [3, 10, 5, 16, 8, 4, 2]. On s'arrête à 2 car la longueur de 2 avait été calculée et vallait 2
On obtient non seulement la longueur de 3 mais aussi celles des éléments de la chaîne: l(4) = 3, l(8)= 4, l(16)= 5, l(5) = 6, l(10) = 7 et l(3) = 8. On les enregistre alors dans le dico.
* Maintenant on passe au cas c= 4. Et bien il n'y a rien à faire car 4 est déjà dans le dico. De même pour c= 5.
* On passe donc à c = 6. La chaîne est [6,3], car 3 est dans le dico.
* On passe à c= 7. La chaîne est [7,22,11,34,17,52,26,13,40,20,10], car 10 est dans le dico...
"""


def longueur_maximale_bis(N):
    dico_longueurs = {1: 1} # on initialise un dictionnaire contenant les longueurs des chaînes.
                            # La chaîne issue de 1 a pour longueur 1
    longueur_max = 1
    c_max = 1
    for c in range(2, N+1):
        t =[c] # t est un tableau qui va contenir les valeurs de la chaîne issue de c
        u = c
        while u not in dico_longueurs: # on calcule la chaîne jusquà ce que 
                                       # l'on tombe sur un nombre dont on connaît la longueur.
            u = f(u)
            t.append(u)
        # arrivé ici u le dernier élément de t est dans dico,
        # on met à jour le dico en rentrant les nouvelles longueurs des éléments de t 
        n = len(t)
        for k in range(n):
            dico_longueurs[t[k]] = dico_longueurs[u] + (n-1-k)
            if dico_longueurs[t[k]] > longueur_max:
                longueur_max = dico_longueurs[t[k]]
                c_max = t[k]
    return longueur_max, c_max


t0 = time.clock()
print(longueur_maximale_bis(10**8))
t1 = time.clock()
duree_calcul = t1 -t0
print("temps de calcul ", duree_calcul)

# renvoie (351, 77031) pour N = 10**5 en 0.4 s et (525,837799) pour 10**6 en 4 s
# C'est une jolie amélioration!!
# renvoie (686, 8400511) pour N = 10^7 en 41 s


## Attention à la division flottante n/ 2 au lieu de n//2
def f(n):
    if n % 2 ==0:
        return n/2 # on écrit n/2 au lieu de n//2
    else:
        return 3*n+1

for c in [2**1024,2**10252]:
    print( longueur_chaine(c))

"""on obtient 1025 puis 
OverflowError: integer division result too large for a float
 car 2**1023 est la plus grande puissance de deux représentable par un nbre flottant"""
